<?php
// HTTP-cat, written by seven@armchairscientist.co.uk, Nov 2018
// 
// similar to IRC-cat, but rather than a socket, it is a PHP file that
// can be POST'd to which'll then get added to the IRC queue
// 
// accepts HTTP POST and adds to IRC queue


// use these prefixes to determine if a valid recipient, otherwise
// treat the entire string as a message to the default channel
$valid_chars = array("#", "@");
// used when no channel/user is specified in the string
$default_send_channel = "#testchannel";
// look up identifier for existing bot connection, or specify a new one
$identifier = "7";

require("conf/config_db.php");
require("conf/config_httpcat.php");
require("includes/class.db_pdo.php");

$db_local = new db();
$db_local->connect($db_host, $db_user, $db_pass, $db_name);

require("sep93db.class.php");
$sep93db = new sep93db($db_local);

if(empty($_REQUEST['data']) or empty($_REQUEST['secret'])) {
	echo "Missing post fields";
	exit();
}
if(empty($_REQUEST['secret']) or $_REQUEST['secret'] != $sep93_http_secret) {
	echo "Invalid authentication";
	exit();
}

if($data = $sep93db->splitRawInput($_REQUEST['data'], $default_send_channel)) {
	if(isset($data['recipients']) and is_array($data['recipients'])) {
		foreach($data['recipients'] as $send_to) {
			$line = array();
			$line['send_to'] = $send_to;
			$line['message'] = $data['message'];
			$line['identifier'] = $identifier;
			$sep93db->q2send($line);
		}
	}
}

?>
