<?php
// IRC-cat, written by seven@armchairscientist.co.uk, Nov 2018
// inspired by this article, https://www.metabrew.com/article/how-we-use-irc-at-lastfm
// 
// binds to a port and forwards messages to IRC
// uses the database queuing system from sep93

$host = "127.0.0.1";
$port = "40000";
$default_send_channel = "#sep93";

if(isset($argv[1]) and is_numeric($argv[1]))
	$port = $argv[1];
if(isset($argv[2]) and !empty($argv[2]))
	$default_send_channel = $argv[2];

$host_string = "tcp://$host:$port";
// used when no channel/user is specified in the string
// look up identifier for existing bot connection, or specify a new one
$identifier = "7";

require("conf/config_db.php");
require("includes/class.db_pdo.php");

$db_local = new db();
$db_local->connect($db_host, $db_user, $db_pass, $db_name);

require("sep93db.class.php");
$sep93db = new sep93db($db_local);

$server = stream_socket_server($host_string, $errno, $error_message);
if($server === false) {
	throw new UnexpectedValueException("Could not bind to socket: $error_message");
}

for(;;) {
	$client = @stream_socket_accept($server);
			
	if($client) {
		if($data = $sep93db->splitRawInput(stream_get_contents($client), $default_send_channel)) {
			if(isset($data['recipients']) and is_array($data['recipients'])) {
				foreach($data['recipients'] as $send_to) {
					$line = array();
					$line['send_to'] = $send_to;
					$line['message'] = $data['message'];
					$line['identifier'] = $identifier;
					$sep93db->q2send($line);
				}
			}
		}

		stream_copy_to_stream($client, $client);
		fclose($client);
	}
}
?>
