<?php

// class to connect to IRC and process messages
// an IRC client I guess
// August 2018, nvm
//

class sep93IRC {

	public $server = 'ssl://irc.armchairscientist.co.uk';
	public $port = 6697;
	public $pass = 'pass';
	public $nick = 'bot2';
	public $channel = '#neiltest2';
	public $current_nick = "";

	public $connection = null;
	public $error_num = null;
	public $error_string = null;

	public $current_channels = array();
	public $chan_regex = '(:[^ ]+) ([A-Z]*) (#?(.+?)) :([^\n]+)';
	public $privmsg_regex = '(:[^ ]+) ([A-Z]*) (.+?) :([^\n]+)';

	public $nick_seperators = array(":", ",", ";", "-");

	function __construct() {
	}

	function connect($server = null, $port = null, $pass = null, $nick = null) {
		if(is_null($server))
			$server = $this->server;
		if(is_null($port))
			$port = $this->port;
		if(is_null($pass))
			$pass = $this->pass;
		if(is_null($nick))
			$nick = $this->nick;
		$error_num = $error_string = null;
		$this->connection = fsockopen($server, $port, $err_num, $error_string);
		echo "OPENED CONNECTION";
		
		if(!$this->connection) {
			$this->error_string = $errstr;
			$this->error_num = $error_num;
			return false;
		}
		echo "TRYING TO SEND PASS";
		$this->send(sprintf("PASS %s", $pass), $this->connection);
		echo "TRYING TO SEND USER";
		$this->send('USER username "1" "1" :username_again', $this->connection);
		echo "TRYING TO SEND NICK";
		$this->send(sprintf("NICK %s", $nick), $this->connection);
		$this->current_nick = $nick;
		return $this->connection;
	}

	function send($msg, $conn = null) {
		if(is_null($conn))
			$conn = $this->connection;
		return fwrite($conn, $msg."\n");
	}
	
	function say($to, $msg, $conn = null) {
		if(is_null($conn))
			$conn = $this->connection;
		return fwrite($conn, sprintf("PRIVMSG %s :%s", $to, $msg)."\n");
	}

	function join_channel($channel, $conn = null) {
		if(is_null($conn))
			$conn = $this->connection;
		if(empty($this->current_channels[$channel])) {
			$this->send(sprintf("JOIN %s", $channel), $this->connection);
			$this->current_channels[$channel]['time'] = time();
		}

	}

	function keepalive($token, $conn = null) {
		if(is_null($conn))
			$conn = $this->connection;
		$this->send("PONG :$token", $this->connection);
	}

	function parseMessage($array) {
		if(!is_array($array)) {
			return false;
		}

		$msg_hostmask = substr($array[1], 1);
		
		$host_parts = explode("@", $msg_hostmask);
		$name_parts = explode("!", $host_parts[0]);

		$data['nick'] = $data['user'] = $data['host'] = $data['hostmask'] = null;

		if(!empty($name_parts[1]))
			$data['user'] = $name_parts[1];
		if(!empty($name_parts[0]))
			$data['nick'] = $name_parts[0];
		if(!empty($host_parts[1]))
			$data['host'] = $host_parts[1];
		$data['hostmask'] = $msg_hostmask;

		if(empty($data['nick']) or empty($data['host']))
			return false;

		$data['type'] = $array[2];
		$data['source'] = $array[3];
		$data['msg'] = $array[5];

		$data['direct_message'] = false;
		$data['channel_message'] = false;

		if($data['source'] == $this->current_nick) {
			$data['direct_message'] = true;
		} elseif(substr($data['source'], 0, 1) == "#") {
			$data['channel_message'] = true;
		}

		return $data;
	}

	function processInput($input) {
		
	}

	function processRule($rule, $msg_info) {
		if(!is_array($rule) or !is_array($msg_info))
			return false;
		if(!empty($rule['hostmask']) and $rule['hostmask'] != "*" and $rule['hostmask'] != "*!*@*") {
			$host_parts = explode("@", $rule['hostmask']);
			$name_parts = explode("!", $host_parts[0]);

			$data['nick'] = $data['user'] = $data['host'] = $data['hostmask'] = null;

			if(!empty($name_parts[1]))
				$rule['user'] = $name_parts[1];
			if(!empty($name_parts[0]))
				$rule['nick'] = $name_parts[0];
			if(!empty($host_parts[1]))
				$rule['host'] = $host_parts[1];

			// TODO: identify wildcards in host parts
			if($rule['host'] != $msg_info['host']) {
				echo "Host doesn't match, skipping";
				return false;
			}
			if($rule['user'] != $msg_info['user'] and $rule['user'] != "*") {
				echo "User doesn't match, skipping";
				return false;
			}
			if($rule['nick'] != $msg_info['nick'] and $rule['nick'] != "*") {
				echo "Nick doesn't match, skipping";
				return false;
			}
			
		}

		// if the rule is for in the channel only and it's not a channel message, then drop it
		if($rule['sent_to'] == 'channel' and !$msg_info['channel_message'])
			return false;
		// if the rule is for private messages, and this isn't a private message, then drop it
		if($rule['sent_to'] == 'user' and !$msg_info['direct_message'])
			return false;

		$rule_matched = false;
		if($rule['require_nick_prefix']) {
			if($this->isRuleRegEx($rule['trigger_text'])) {
				$new_rule = "~(".$this->current_nick."\s*[".implode("", $this->nick_seperators)."]\s*)";
				$new_rule .= substr($rule['trigger_text'], 1);
				if(preg_match($new_rule, $msg_info['msg'], $rule_match))
					$rule_matched = true;
				// TODO inject nickname into regex
			} else {
				// TODO: support different suffixes (,;) inc spaces etc
				$new_rule = "~(".$this->current_nick."\s*[".implode("", $this->nick_seperators)."]\s*)";
				$new_rule .= $rule['trigger_text']."~";
				if(preg_match($new_rule, $msg_info['msg'], $rule_match)) {
					$rule_matched = true;
				}
//				if($this->current_nick.":".$rule['trigger_text'] == $msg_info['msg']) {
//					$rule_matched = true;
//				}
			}
		} else {
			if($this->isRuleRegEx($rule['trigger_text'])) {
				if(preg_match($rule['trigger_text'], $msg_info['msg'], $rule_match)) {
					$rule_matched = true;
				}
			} elseif($rule['trigger_text'] == $msg_info['msg']) {
				$rule_matched = true;
			}
		}

		if($rule_matched) {
			if(!empty($rule['file_include'])) {
				$filename = basename($rule['file_include']);
				if(file_exists("scripts/$filename")) {
					$test_syntax = shell_exec("php -l scripts/".$filename);
					$syntax_error = preg_replace("/Errors parsing.*$/", "", $test_syntax, -1, $error_count);
					if($error_count > 0) {
						$rule['response_text'] = "Syntax error parsing $filename";
					} else {
						ob_start();
						include("scripts/$filename");
						$file_output = ob_get_clean();
						$rule['response_text'] = $file_output;
					}
				} else {
					echo "ERROR: missing include file 'scripts/$filename'";
				}
			}
			if($msg_info['direct_message']) {
				$this->say($msg_info['nick'], $rule['response_text']);
			} elseif($msg_info['channel_message']) {
				$this->say($msg_info['source'], $rule['response_text']);
			} else {
				echo "DEBUG: not a direct or channel message";
			}
			if($rule['last_rule']) {
				return true;
			}
			return 0;
		}
	}

	function isRuleRegEx($input) {
		if(substr($input, 0, 1) == "~")
			return true;
		return false;	
	}

	function set_channel_names_list($input) {
		// seperate input line into name of channel
		$names = explode(":", $input);
		$channel = explode(" = ", $names[1]);
		$channel_name = trim($channel[1]);
		$name_list = explode(" ", $names[2]);
		$this->current_channels[$channel_name]['names'] = $name_list;
		echo "set $channel_name to ".implode(",", $name_list);
	}

















}
